<template>
  <div class="page-container d-flex">
    <form @submit="submit" class="d-flex flex-column card-form p-20 radius">
      <h2>Inscription</h2>
      <div class="p-10 d-flex flex-column">
        <label for="email">Adresse E-mail</label>
        <input
          v-model="emailValue"
          id="email"
          class="input radius"
          type="email"
          name="email"
        />
        <p class="error" v-if="emailError">{{ emailError }}</p>
      </div>

      <div class="p-10 d-flex flex-column">
        <label for="password">Mot de passe</label>
        <input
          v-model="passwordValue"
          id="password"
          class="input radius"
          type="password"
          name="password"
        />
        <p class="error" v-if="passwordError">{{ passwordError }}</p>
      </div>

      <button class="button radius" type="submit">Inscription</button>
      <router-link class="d-flex p-10 gologin" to="/login"
        >Déjà membre ?
      </router-link>
    </form>
  </div>
</template>

<script setup lang="ts">
import { z } from "zod";
import { toFormValidator } from "@vee-validate/zod";
import { useField, useForm } from "vee-validate";
import type { UserForm } from "@/shared/interfaces";
import { createUser } from "@/shared/services/user.service";
import { useRouter } from "vue-router";

const router = useRouter();

const validationSchema = toFormValidator(
  z.object({
    email: z
      .string({ required_error: "Vous devez renseigner votre email" })
      .email("format de l'email incorect"),
    password: z
      .string({ required_error: "Vous devez renseigner votre Mot de passe" })
      .min(8, "Mot de passe trop court 8 caractères minimum"),
  })
);

const { handleSubmit, setErrors } = useForm({
  validationSchema,
});

const submit = handleSubmit(async (formValue: UserForm) => {
  try {
    await createUser(formValue);
    router.push("/login");
  } catch (e) {
    console.log(e);
  }
});

const { value: emailValue, errorMessage: emailError } = useField("email");
const { value: passwordValue, errorMessage: passwordError } =
  useField("password");
</script>

<style scoped lang="scss">
form {
  height: auto;
  margin: auto;
  width: 450px;
}

@media screen and (max-width: 500px) {
  form {
    width: calc(100% - 30px);
  }
}

.gologin {
  justify-content: center;
  color: #b3bfc7;
}

.gologin:hover {
  color: #0097e6;
  text-decoration: underline;
}

.error {
  padding: 10px;
  margin: 0;
  box-sizing: border-box;
  color: #c23616;
}

label {
  padding-bottom: 5px;
}

button {
  margin: 10px;
}
</style>
